/*===========================================================================

	SPW Config dialog

	$ Version 3.0  15/10/97  18:12:24 $

	Copyright 19941997 by Marco Savegnago.  All rights reserved.
	This software may be freely distributed and used, but it may not
	under any circumstances be sold by anyone other than the author.
	It may be distributed by a commercial company as long as it is
   for no cost.

===========================================================================*/

#ifndef	__CONFDLG_H
#define	__CONFDLG_H

#include <owl/dialog.h>
#include <owl/edit.h>
#include <owl/radiobut.h>
#include <owl/hotkey.h>

//
// Record to communicate the properties of an application to the dialog
// and back to AppLauncher.
//

#define 	PASSWORD_LEN    256
#define  CAPTION_LEN		 3

struct TConfigData
{
	TConfigData()
	:
		hotkeyActivation(false),
		topmostWindow(false),
		iconizeAfterUse(false),
		clipChallenge(false),
		copyToClipboard(true),
      hotkeyValue(0)
	{
		captionHeight[0] 	=	NULL;
	}

	uint16	hotkeyActivation;
	uint16	hotkeyValue;
	uint16	clipChallenge;

	uint16   topmostWindow;
	char		captionHeight[CAPTION_LEN];
	uint16	iconizeAfterUse;
	uint16   copyToClipboard;
};

//
// Allow user to the properties of an application.
//
class TConfigDialog
:
	public TDialog
{

public:
	TConfigDialog(TWindow* parent, int resId, TConfigData* data);

private:
	// Controls.
	//
	TCheckBox*		hotkeyActivation;

	THotKey*			hotkeyValue;
	TCheckBox*		clipChallege;

	TCheckBox*		topmostWindow;
	TEdit*        	captionHeight;
	TCheckBox*		iconizeAfterUse;

	TCheckBox*    	sendToClipboard;

	void    			HandleHotkeyCB();

	void				OnHelp();

	virtual	void	SetupWindow();

	DECLARE_RESPONSE_TABLE(TConfigDialog);
};

#endif
