/*===========================================================================

	SPW Main thing

	$ Version 3.0  15/10/97  18:12:24 $

   Copyright 1994~1997 by Marco Savegnago.  All rights reserved.
   This software may be freely distributed and used, but it may not
	under any circumstances be sold by anyone other than the author.
   It may be distributed by a commercial company as long as it is
   for no cost.

===========================================================================*/

//  Local include

#include "spw.h"
#include "spwkeys.h"
#include "spwhello.h"
#include	"olssm.h"

//  OWL Include

#include <owl\clipboar.h>
#include	<winsys/registry.h>

//  CRTL    include

#include <string.h>
#include <cstring.h>
#include <stdio.h>

//  Resource ID include

#include "spw.rh"

//	Help ID include

#include "help/help.h"

const	dword	dwCurrentMajorVersion				=	3;
const	dword	dwCurrentMinorVersion				=	0;
const	dword	dwCurrentBuild							=	1;

// For diagnostics
// DIAG_DEFINE_GROUP(TWinPass,1,0);

DEFINE_RESPONSE_TABLE1(TComboEdit,TEdit)
    EV_WM_CHAR,
END_RESPONSE_TABLE;

//
// This is where we look for the <ENTER> key and execute commands
//
void TComboEdit::EvChar(UINT key, UINT /*repeatCount*/, UINT /*flags*/)
{
	if (key == VK_RETURN)
	{
		//
		// Get Line into local buffer for parsing
		//

		GetText(EditBuf, sizeof(EditBuf));

		if (!EditBuf[0]) // Ignore empty strings
					return;

		ExecuteCmd(EditBuf);

		if(TConfigData* config = &((TWinPass *)GetApplication())->config)
		{
			if(config->iconizeAfterUse)
				Parent->Parent->Show(SW_MINIMIZE);
      }

		return;
	}
	else
		DefaultProcessing();

	return;
}

void TComboEdit::ExecuteCmd(char* cmd)
{
   char		szReply[256];

	if(OLSSMAutoClientPasswordReply(cmd, szReply, sizeof(szReply) - 1))
   {
      MessageBox(szReply, "Result", MB_OK);

      //  Has the result to be copied to the clipboard ?

      if(TConfigData* config = &((TWinPass *)GetApplication())->config)
      {
      	if(config->copyToClipboard==true)
         	copyToClipboard(szReply);
      }

      Combo->InsertString(EditBuf,0);

      Clear();

      return;
   }

   MessageBox("No password found!", "ERROR", MB_ICONEXCLAMATION|MB_OK);
   return;
}

//	 Copy the string to the clipboard as text

void TComboEdit::copyToClipboard(char *str)
{
	HANDLE  StringGlobalHandle;
	LPSTR   StringGlobalPtr;

	 //  Allocate the buffer

	StringGlobalHandle = GlobalAlloc (GMEM_MOVEABLE, (LONG)lstrlen(str) + 1);

	if (StringGlobalHandle)
	{
		//  If it is OK the fix it

		StringGlobalPtr = (char*)GlobalLock(StringGlobalHandle);

		if (StringGlobalPtr)
		{
			//  Copy the resulting string

				lstrcpy(StringGlobalPtr, str);
       		GlobalUnlock(StringGlobalHandle);

				TClipboard  clipboard(HWindow);

			//  Then copy to the clipboard

            if (clipboard)
				{
                clipboard.EmptyClipboard();
                clipboard.SetClipboardData(CF_TEXT, StringGlobalHandle);
                clipboard.CloseClipboard();
                return;
				}
            else
					 GlobalFree(StringGlobalHandle);
     	}
		else
			GlobalFree(StringGlobalHandle);
	 }

	 return;
}

//------------------------------------------------------------------------

TLineEdit::TLineEdit(TWindow* p, int w, int h)
:
	TComboBox(p, COMBO_ID, -1, -1, w, h, CBS_DROPDOWN, CMDBUFSIZE-1)
{
	Ed = new TComboEdit(this, CMDBUFSIZE-1);

  // We don't want a sorted list!
	Attr.Style &= ~CBS_SORT;
}

void	TLineEdit::SetString(const char*	szString)
{
	Ed->SetText(szString);
}


//------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TMakePassFrame, TFloatingFrame)
	EV_WM_SYSCOMMAND,
   EV_WM_HOTKEY,
   EV_COMMAND(CM_CONFIG, 			CmConfig),
   EV_COMMAND(CM_ABOUT,  			CmAbout),
   EV_COMMAND(CM_HELP,  			CmHelp),
   EV_COMMAND(CM_PASSWORDSETUP,  CmPasswordSetup),
   EV_WM_ENTERIDLE,
END_RESPONSE_TABLE;

bool	TMakePassFrame::bquiet;

TMakePassFrame::TMakePassFrame(TWindow* client, char* title, WORD captionHeight, bool Topmost, WORD hotkey)
:
	TFloatingFrame(0, title, client),
	wHotkey(hotkey),
	F1Pressed(false)
{
	//
	// We can set our own attributes, but must be before EnableTiny...
	//
	Attr.Style = WS_POPUP | WS_BORDER | WS_SYSMENU | WS_MINIMIZEBOX;
  	Attr.Style &= ~WS_MAXIMIZEBOX|WS_MAXIMIZE;

	if(Topmost)
		Attr.ExStyle |= WS_EX_TOPMOST;

#if defined(BI_PLAT_WIN32)
  	Attr.ExStyle |= WS_EX_WINDOWEDGE;
#endif

	//
	// Or we can be specific, even make it BIGGER if we want
	// If we set the option CloseBox flag to true, then clicking the box
	// will close the window instead of displaying the system menu
	//
	EnableTinyCaption(captionHeight, false);
	//
	// Create our combo box and size it for an edit line and 5 text items
	// What's the correct way to get the height of an edit control?
	//
	int lineH = GetSystemMetrics(SM_CYCAPTION)+2; // 1pixel top & bottom border

	Cmd = new TLineEdit(this, EDITWIDTH, lineH*6);

	Attr.X = (GetSystemMetrics(SM_CXSCREEN) - EDITWIDTH)/2;
	Attr.Y = (GetSystemMetrics(SM_CYSCREEN) - lineH*6)/2;
	Attr.W = EDITWIDTH;
	Attr.H = 0;  // Resize ourselves later, when we know the actual size
}

void TMakePassFrame::EvSysCommand(uint cmdType, TPoint& p)
{
   switch(cmdType)
   {
      case	SC_MAXIMIZE:
      	return;

   	case	SC_RESTORE:
      {
      	if(TConfigData* config = &((TWinPass *)GetApplication())->config)
			{
				if(config->clipChallenge)
      			copyDataFromClipboard();
         }
      	break;
      }
   	case	CM_CONFIG:
      	CmConfig();
         break;

      case  CM_ABOUT:
      	CmAbout();
         break;

   	case	CM_HELP:
      	CmHelp();
         break;

   	case	CM_PASSWORDSETUP:
      	CmPasswordSetup();
      	break;

      default:
      	break;
   }

	TFloatingFrame::EvSysCommand(cmdType, p);
}

void TMakePassFrame::copyDataFromClipboard()
{
  TClipboard cb(*this);

  if (!cb)
    return;  // clipboard open by another window

  if(HANDLE cbhdl = cb.GetClipboardData(CF_TEXT))
  {
    char far* text = (char far*)::GlobalLock(cbhdl);
    Cmd->SetString(text);
    ::GlobalUnlock(cbhdl);
  }
}

void TMakePassFrame::EvEnterIdle(UINT source, HWND /*hWndDlg*/)
{
	// if the keystate high bit is set, then the key is pressed
	if (source == MSGF_MENU && (::GetKeyState(VK_F1) & 0x8000))
	{
		F1Pressed = true;
		PostMessage(WM_KEYDOWN, VK_RETURN);
	}
	else
		DefaultProcessing();
}

void TMakePassFrame::CmHelp()
{
	WinHelp(TWinPass::HelpName,  HELP_CONTENTS, 0);
}

void TMakePassFrame::SetupWindow()
{
#ifdef  __USEDDE
	TWinPass::This = this;
#endif

	if(!bquiet)
	{
		TSplashDialog splash(this, IDD_HELLO);
		splash.Execute();
	}

	TFloatingFrame::SetupWindow();

	// Append about menu item to system menu.
	//

	TSystemMenu sysMenu(HWindow);
	sysMenu.AppendMenu(MF_SEPARATOR, 0, (LPSTR)0);
	sysMenu.AppendMenu(MF_STRING, CM_CONFIG, "Configure...");
	sysMenu.AppendMenu(MF_STRING, CM_PASSWORDSETUP, "Password Setup...");

	sysMenu.AppendMenu(MF_SEPARATOR, 0, (LPSTR)0);
	sysMenu.AppendMenu(MF_STRING, CM_ABOUT, "About...");

	sysMenu.AppendMenu(MF_SEPARATOR, 0, (LPSTR)0);
	sysMenu.AppendMenu(MF_STRING, CM_HELP, "Help");

	//
	// Resize window to actual combo box size
	//
	TRect cr = Cmd->GetWindowRect();
	TRect newRect = GetWindowRect();
	MoveWindow(newRect.left, newRect.top, newRect.Width(), CaptionHeight + cr.Height(), true);

#ifdef  __USEDDE

	 Service = Topic = Item = 0;

	 // The strings below are the 'Service', 'Topic' and 'Item' identifiers
	 // that this application makes available, through DDE, to other
	 // applications.
	 //

	 Service = DdeCreateStringHandle(InstId(), "PKLIB_SERVER", 		CP_WINANSI);
    Topic   = DdeCreateStringHandle(InstId(), "PACKET_PASSWORD", 	CP_WINANSI);
    Item    = DdeCreateStringHandle(InstId(), "NMD2_SUPPORT", 		CP_WINANSI);

    if (Service && Topic && Item)
	 {
		  if (DdeNameService(InstId(), Service, 0, DNS_REGISTER) == 0)
		  {
				MessageBox("DDE Registration failed.", Title, MB_ICONSTOP);
				PostQuitMessage(0);
		  }
	 }
	 else
	 {
		  MessageBox("String creation failed.", Title, MB_ICONSTOP);
		  PostQuitMessage(0);
	 }
#endif

	 if(wHotkey)
	 {
		 LRESULT	result = SendMessage(WM_SETHOTKEY,wHotkey);

		 char	*msg = NULL;

		 switch(result)
		 {
			case 2:
				msg = "HOTKEY is used by another application!";
				break;
			case 0:
				msg = "WM_SETHOTKEY failed, invalid HWND!";
				break;
			case -1:
				msg = "WM_SETHOTKEY failed, invalid hot key";
				break;
		}
		if(msg)
		{
			MessageBeep(-1);
			MessageBox(msg,"HOTKEY!",MB_OK);
		}
	}
}

TMakePassFrame::~TMakePassFrame()
{

#ifdef  __USEDDE

	 // This clean up is required for those resources that were allocated during
	 // the DDE conversation.
	 //
    if (HConv)
		  DdeDisconnect(HConv);   // Let the other party know we are leaving

	 if (InstId())
	 {
        DdeNameService(InstId(), Service, 0, DNS_UNREGISTER);

        if (Service)
				DdeFreeStringHandle(InstId(), Service);
		  if (Topic)
            DdeFreeStringHandle(InstId(), Topic);
		  if (Item)
            DdeFreeStringHandle(InstId(), Item);
	 }
#endif
}

#ifdef  __USEDDE

//
// This function is used to compare incoming Topic and Service requests.
// This example DDE Server only makes one Service and one Topic available
// so the logic is simple for this case but could be more complex for
// Servers that offer multiple Services or Topics.
//

bool        TMakePassFrame::MatchTopicAndService(HSZ topic, HSZ service)
{
    if (DdeCmpStringHandles(Topic, topic) == 0)
        if (DdeCmpStringHandles(Service, service) == 0)
                                            return true;

	 return false;
}

//
// This function is used to compare incoming Topic and Item pair requests.
// This Server only makes one Topic with one Item available so the logic is
// simple for this case but could be more complex if the Server offered
// multiple Items for multiple Topics.
//

bool        TMakePassFrame::MatchTopicAndItem(HSZ hsz1, HSZ hsz2)
{
    if (DdeCmpStringHandles(Topic, hsz1) == 0)
        if (DdeCmpStringHandles(Item, hsz2) == 0)
                                        return true;

	 return false;
}

//
// This function responds to 'system wide' polling of any available
// Services with specific Topics, any Topics with specific Services or any
// Services with any Topics.  It simply replies with a match, if there is
// one, so that the polling application can open data discussions later, if
// desired.
//

HDDEDATA    TMakePassFrame::WildConnect(HSZ hsz1, HSZ hsz2, WORD wFmt)
{
    HSZPAIR hszpTemp[] = { { Service, Topic }, { 0, 0 } };

    if (!hsz1 && !hsz2)    // Returns all if true
		  return DdeCreateDataHandle(InstId(), (LPBYTE)&hszpTemp[0], sizeof(hszpTemp), 0L, 0, wFmt, 0);

    if (!hsz1 && DdeCmpStringHandles(hsz2, Service) == 0)
		  return DdeCreateDataHandle(InstId(), (LPBYTE)&hszpTemp[0], sizeof(hszpTemp), 0L, 0, wFmt, 0);

    if (DdeCmpStringHandles(hsz1, Topic) == 0 && !hsz2)
		  return DdeCreateDataHandle(InstId(), (LPBYTE)&hszpTemp[0], sizeof(hszpTemp), 0L, 0, wFmt, 0);

	return 0;
}

DWORD   TMakePassFrame::InstId()
{
	return ((TWinPass*)GetApplication())->InstId;
}

HDDEDATA    TMakePassFrame::DataRequested(WORD)
{
	return 0;
}

void        TMakePassFrame::UpdateData()
{
	 DdePostAdvise(InstId(), Topic, Item);
}
#endif

//	 Execute configuration dialog

void TMakePassFrame::CmConfig()
{
	if (F1Pressed)
	{
		WinHelp(TWinPass::HelpName,  HELP_CONTEXT, Menu_Configuration);
		F1Pressed = false;
	}
	else
	{
		//	Get app config data

		TConfigData* config = &((TWinPass *)GetApplication())->config;

		//	Create and execute config dialog

		TConfigDialog   configDialog(this, IDD_CONFIG_DIALOG, config);

		configDialog.Execute();

		//	If the caption height is changed then repaint it

		/*
		if(CaptionHeight != atoi(config->captionHeight))
		{
			EnableTinyCaption(atoi(config->captionHeight), false);
			Invalidate(false);
		}
		*/
	}
}

/*
	 User function that reply to About Menu Item
*/

void TMakePassFrame::CmAbout()
{
	if (F1Pressed)
	{
		WinHelp(TWinPass::HelpName, HELP_CONTEXT, Menu_About);
		F1Pressed = false;
	}
	else
	{
		TDialog aboutDialog(this, IDD_AUTORE_DIALOG);
		aboutDialog.Execute();
	}
}

/*
	 Execute Password setup	dialog
*/

void TMakePassFrame::CmPasswordSetup()
{
	if (F1Pressed)
	{
		WinHelp(TWinPass::HelpName, HELP_CONTEXT, Menu_Password_Setup);
		F1Pressed = false;
	}
	else
   	OLSSMEditClientPasswordsDlg(HWindow);
}

//  Static

#ifdef  __USEDDE
TMakePassFrame*     TWinPass::This;
#endif

const char *        TWinPass::ApplicationName = "SPW";
char                TWinPass::HelpName[MAXPATH];

#ifdef	__WIN32__
const char *TWinPass::szREGBase					=	"SOFTWARE\\Oltre\\SPW\\CurrentVersion";
const char *TWinPass::szREGMajorVersion		=	"MajorVersion";
const char *TWinPass::szREGMinorVersion		=	"MinorVersion";
const char *TWinPass::szREGBuild					=	"Build";
const char *TWinPass::szREGInstallationDate	=	"InstallationDate";
const char *TWinPass::szREGHelpFilename		=	"HelpFilename";

const	char *TWinPass::szREGDebugSection		= 	"Debug";
const	char *TWinPass::szREGDebug		    		= 	"Debug";

const	char *TWinPass::szREGHotkeySection		= 	"Hotkey";
const	char *TWinPass::szREGHotkeyActivation  = 	"HotkeyActivation";
const	char *TWinPass::szREGHotkeyValue			= 	"HotkeyValue";
const	char *TWinPass::szREGClipChallenge 		=	"CopyChallangeFromClipboard";


const	char *TWinPass::szREGTopmostWindow			= 	"TopmostWindow";
const	char *TWinPass::szREGCaptionHeight			=  "CaptionHeight";
const	char *TWinPass::szREGCopyToClipboard	   =  "CopyToClipboard";
const	char *TWinPass::szREGIconizeAfterUse	   =  "IconizeAfterUse";

#else
char                TWinPass::ProfileName[MAXPATH];

const	char *TWinPass::INIDebugSection		  	= 	"Debug";
const	char *TWinPass::INIDebug		    		= 	"Debug";

const	char *TWinPass::INIHotkeySection			= 	"Hotkey";
const	char *TWinPass::INIHotkeyActivation    = 	"HotkeyActivation";
const	char *TWinPass::INIHotkeyValue			= 	"HotkeyValue";
const	char *TWinPass::INIClipChallenge 		=	"CopyChallangeFromClipboard";


const	char *TWinPass::INITopmostWindow			= 	"TopmostWindow";
const	char *TWinPass::INICaptionHeight			=  "CaptionHeight";
const	char *TWinPass::INICopyToClipboard	   =  "CopyToClipboard";
const	char *TWinPass::INIIconizeAfterUse	   =  "IconizeAfterUse";

#endif
/*
	 Application ctor
*/

TWinPass::TWinPass()
:
	 TApplication(ApplicationName)
#ifdef  __USEDDE
	 ,CallBackProc((FARPROC)CallBack)
#endif
{
	ReadINIFile();

	MakeHotkey();
}

void	TWinPass::MakeHotkey()
{
	wHotkey = 0;

	if(config.hotkeyActivation)
   	wHotkey	=	config.hotkeyValue;
}

void TWinPass::ReadINIFile()
{
#ifdef	__WIN32__
   TRegKey		RegSPWCurrentBase(HKEY_LOCAL_MACHINE, TWinPass::szREGBase, KEY_ALL_ACCESS, TRegKey::NoCreate);

   if(RegSPWCurrentBase)
   {
      dword	dwTMajorVersion		=	TRegValue(RegSPWCurrentBase, 	TWinPass::szREGMajorVersion);
		dword	dwTMinorVersion		=	TRegValue(RegSPWCurrentBase, 	TWinPass::szREGMinorVersion);
      dword	dwTBuild					=	TRegValue(RegSPWCurrentBase,	TWinPass::szREGBuild);
      dword	dwTInstallationDate	=	TRegValue(RegSPWCurrentBase,	TWinPass::szREGInstallationDate);

		TRegValue	RegSPWCurrentBaseHelpFilename(RegSPWCurrentBase, TWinPass::HelpName);

      if(RegSPWCurrentBaseHelpFilename.GetDataType() == REG_SZ)
         strncpy(TWinPass::HelpName, RegSPWCurrentBaseHelpFilename.GetData(), MAXPATH);
 		else
      	strcpy(TWinPass::HelpName,"SPW.HLP");

      TRegKey		RegSPWCurrentBaseHotKey(RegSPWCurrentBase, TWinPass::szREGHotkeySection, KEY_ALL_ACCESS, TRegKey::NoCreate);

      if(RegSPWCurrentBaseHotKey)
      {
         //	Activate the application on hotkey?

         config.hotkeyActivation = TRegValue(RegSPWCurrentBaseHotKey, TWinPass::szREGHotkeyActivation);

         config.hotkeyValue		= TRegValue(RegSPWCurrentBaseHotKey, TWinPass::szREGHotkeyValue);

         //	Copy challange from clipboard when invoched from an hotkey

         config.clipChallenge		= TRegValue(RegSPWCurrentBase, TWinPass::szREGClipChallenge);

         /*******************************************************************
            Get CopyToClipboard item from the REG file
         *******************************************************************/

          config.topmostWindow = TRegValue(RegSPWCurrentBase, TWinPass::szREGTopmostWindow);

         /*******************************************************************
            Get Caption height from the REG file
         *******************************************************************/

          captionHeight = TRegValue(RegSPWCurrentBase, TWinPass::szREGCaptionHeight);
          itoa(captionHeight, config.captionHeight, 10);

      //	 Inconize after use?

          config.iconizeAfterUse = TRegValue(RegSPWCurrentBase,	TWinPass::szREGIconizeAfterUse);

         /*******************************************************************
            Get CopyToClipboard item from the INI file
         *******************************************************************/

         config.copyToClipboard = TRegValue(RegSPWCurrentBase, TWinPass::szREGCopyToClipboard);

         return;
      }
	}

   dwMajorVersion				=	dwCurrentMajorVersion;
   dwMinorVersion				=	dwCurrentMinorVersion;
   dwBuild						=	dwCurrentBuild;
   dwInstallationDate		=	0;
   config.hotkeyActivation = 	0;

   config.hotkeyValue		= 	0;

   //	Copy challange from clipboard when invoched from an hotkey

   config.clipChallenge		= 0;

/*******************************************************************
   Get CopyToClipboard item from the REG file
*******************************************************************/

    config.topmostWindow 	= 0;

/*******************************************************************
   Get Caption height from the REG file
*******************************************************************/

    captionHeight = 52;

    itoa(captionHeight, config.captionHeight, 10);

//	 Inconize after use?

    config.iconizeAfterUse = 0;

/*******************************************************************
   Get CopyToClipboard item from the INI file
*******************************************************************/

   config.copyToClipboard = 0;

#else

/*******************************************************************
	Get the default ini filename from the resource
*******************************************************************/
	if(ProfileName[0] == NULL)
		 LoadString(IDS_INIFILENAME,ProfileName, MAXPATH);

	if(HelpName[0] == NULL)
		LoadString(IDS_HELPFILENAME, HelpName, MAXPATH);

	//	Activate the application on hotkey?

	config.hotkeyActivation = (GetPrivateProfileInt(INIHotkeySection,INIHotkeyActivation,false,ProfileName) ? 1 : 0);

   config.hotkeyValue		= GetPrivateProfileInt(INIHotkeySection,INIHotkeyValue,false,ProfileName);

	//	Copy challange from clipboard when invoched from an hotkey

	config.clipChallenge	= bool(GetPrivateProfileInt(INIHotkeySection,INIClipChallenge,false,ProfileName));

/*******************************************************************
	Get CopyToClipboard item from the INI file
*******************************************************************/

	 config.topmostWindow = bool(GetPrivateProfileInt(ApplicationName,INITopmostWindow,0,ProfileName));

/*******************************************************************
	Get Caption height from the INI file
*******************************************************************/

	 captionHeight = GetPrivateProfileInt(ApplicationName,INICaptionHeight,52,ProfileName);

	 itoa(captionHeight, config.captionHeight, 10);

//	 Inconize after use?

	 config.iconizeAfterUse = bool(GetPrivateProfileInt(ApplicationName,INIIconizeAfterUse,1,ProfileName));

/*******************************************************************
	Get CopyToClipboard item from the INI file
*******************************************************************/

	config.copyToClipboard = bool(GetPrivateProfileInt(ApplicationName,INICopyToClipboard,1,ProfileName));
#endif

}

//	 Application dtor

TWinPass::~TWinPass()
{
	WriteINIFile();
}

void 	TWinPass::WriteINIFile()
{
#ifdef	__WIN32__

   TRegKey		RegSPWCurrentBase(HKEY_LOCAL_MACHINE, TWinPass::szREGBase);

   RegSPWCurrentBase.SetValue(TWinPass::szREGMajorVersion, 			dwMajorVersion);
   RegSPWCurrentBase.SetValue(TWinPass::szREGMinorVersion, 			dwMinorVersion);
	RegSPWCurrentBase.SetValue(TWinPass::szREGBuild,  					dwBuild);
	RegSPWCurrentBase.SetValue(TWinPass::szREGInstallationDate, 	dwInstallationDate);

   TRegKey		RegSPWCurrentBaseHotKey(RegSPWCurrentBase, TWinPass::szREGHotkeySection);

   //	Activate the application on hotkey?

   RegSPWCurrentBaseHotKey.SetValue(TWinPass::szREGHotkeyActivation,  config.hotkeyActivation);
   RegSPWCurrentBaseHotKey.SetValue(TWinPass::szREGHotkeyValue,		 config.hotkeyValue);

   //	Copy challange from clipboard when invoched from an hotkey

	RegSPWCurrentBase.SetValue(TWinPass::szREGClipChallenge,	config.clipChallenge);

   /*******************************************************************
      Get CopyToClipboard item from the REG file
   *******************************************************************/

    RegSPWCurrentBase.SetValue(TWinPass::szREGTopmostWindow,	config.topmostWindow);

   /*******************************************************************
      Get Caption height from the REG file
   *******************************************************************/

    RegSPWCurrentBase.SetValue(TWinPass::szREGCaptionHeight,	captionHeight);

//	 Inconize after use?

	 RegSPWCurrentBase.SetValue(TWinPass::szREGIconizeAfterUse, config.iconizeAfterUse);

   /*******************************************************************
      Get CopyToClipboard item from the INI file
   *******************************************************************/

	 RegSPWCurrentBase.SetValue(TWinPass::szREGCopyToClipboard, config.copyToClipboard);

#else
   char buff[10];

	itoa(config.hotkeyActivation, buff, 10);
	WritePrivateProfileString(INIHotkeySection,INIHotkeyActivation,buff,ProfileName);

   itoa(config.hotkeyValue, buff, 10);
	WritePrivateProfileString(INIHotkeySection,INIHotkeyValue,buff,ProfileName);

	//	Copy challange from clipboard when invoched from an hotkey ?

	itoa(config.clipChallenge,buff,10);
	WritePrivateProfileString(INIHotkeySection,INIClipChallenge,buff,ProfileName);

	itoa(config.topmostWindow ,buff,10);
	WritePrivateProfileString(ApplicationName,INITopmostWindow,buff,ProfileName);

	WritePrivateProfileString(ApplicationName,INICaptionHeight,config.captionHeight,ProfileName);

	itoa(config.iconizeAfterUse,buff,10);
	WritePrivateProfileString(ApplicationName,INIIconizeAfterUse,buff,ProfileName);

	itoa(config.copyToClipboard,buff,10);
	WritePrivateProfileString(ApplicationName,INICopyToClipboard,buff, ProfileName);
#endif
}

void TWinPass::InitMainWindow()
{
	MainWindow = new TMakePassFrame(0,  "SendPass for Win32 3.0", captionHeight, config.topmostWindow, wHotkey);
	MainWindow->SetIcon(this, IDI_SPW_APPLICATION);
}

#ifdef  __USEDDE

//
// This call back function is the heart of interaction between this program
// and DDE.  Because Windows doesn't pass C++ 'this' pointers to call
// back functions, a static 'this' pointer was used.  If you wanted to
// create a Server that would allow for more than one conversation, using a
// List of conversations and their associated 'this' pointers would be one
// possible method to try.  The XTYP_ constants are described in detail in
// the online help.
//
HDDEDATA FAR PASCAL TWinPass::CallBack(WORD wType, WORD wFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD, DWORD)
{
	 switch (wType)
    {
		  case XTYP_ADVREQ:
			  if (This->MatchTopicAndItem(hsz1, hsz2))
               return This->DataRequested(wFmt);

			  return 0;

		  case XTYP_CONNECT:
				if (!This->HConv)
					 if (This->MatchTopicAndService(hsz1, hsz2))
                                            return (HDDEDATA)1;

				return 0;

		  case XTYP_CONNECT_CONFIRM:
				This->HConv = hConv;
            break;

		  case XTYP_DISCONNECT:
				if (hConv == This->HConv)
				{
					 This->HConv = 0;
				}
				break;

		  case XTYP_ERROR:
				This->MessageBox("A critical DDE error has occured.", This->Title, MB_ICONINFORMATION);
            break;

		  case XTYP_EXECUTE:
				// if (This->MatchTopicAndItem(hsz1, hsz2))

            return DDE_FNOTPROCESSED;

		  case XTYP_POKE:
		  {
				char temp[128];
            strcpy(temp, "The server received: ");
				int size = strlen(temp);
				DdeGetData(hData, (unsigned char *)&temp[size], sizeof(temp) - size, 0);
            ::MessageBox(GetFocus(), temp, This->Title, MB_ICONINFORMATION);
				return (HDDEDATA)DDE_FACK;
        }

		  case XTYP_REQUEST:
            if (This->MatchTopicAndItem(hsz1, hsz2))
					 return This->DataRequested(wFmt);
				return 0;

		  case XTYP_WILDCONNECT:
				return This->WildConnect(hsz1, hsz2, wFmt);
   }

	 return 0;
}

#endif

void TWinPass::InitInstance()
{
  // The code below sets up the DDEML call back function that is used by the
  // DDE Management Library to carry out data transfers between
  // applications.
  //
#ifdef  __USEDDE

	if (DdeInitialize(&InstId, (PFNCALLBACK)(FARPROC)CallBackProc, 0, 0) != DMLERR_NO_ERROR)
	{
		::MessageBox(0,"Initialization failed.", "DDEML Server", MB_ICONSTOP|MB_TASKMODAL);
		PostQuitMessage(0);
	}

#endif
  // Must come after we've initialized DDE since InitInstance will trigger
  // SetupWindow
	 TApplication::InitInstance();

    HAccTable = LoadAccelerators("SPW");

}

int TWinPass::TermInstance(int status)
{
#ifdef  __USEDDE
	 if (InstId)
	 {
		  DdeUninitialize(InstId);
	 }
#endif

	 return TApplication::TermInstance(status);
}

//  Main ...

int OwlMain(int argc, char* argv[])
{
	 /*******************************************************************

	Search for another copy of SPW running

	*******************************************************************/

	HWND searchWindow;

	if(NULL != (searchWindow=FindWindow(NULL,TWinPass::ApplicationName)))
	{
/*******************************************************************
		If found Activate it.
		This force to run ONLY ONE copy of FTW.
*******************************************************************/
		::ShowWindow(searchWindow,SW_SHOWNORMAL);
		return 0;
	}

	if (argc > 1)
   {
	  for(int i=1;i<argc;i++)
	  {
			char *p=argv[i];
			if(*p=='-'||*p=='/')
			{
				 p++;
				 switch(toupper(*p))
				 {
#ifndef	__WIN32__
					  case 'C':      // /C specifica un file di configurazione alternativo
							if (*++p)
								 strcpy(TWinPass::ProfileName, p);
							break;
#endif
                  case	'Q':
							TMakePassFrame::bquiet	=	true;
                     break;
					  default:
							break;
				 }
			}
		}
   }

	return TWinPass().Run();
}

